class Table {
  String[][] data;
  int rowCount;

  float maxVal;

  Table(String filename) {
    String[] rows = loadStrings(filename);
    data = new String[rows.length][];
    for (int i = 1; i<rows.length; i++){
      String[] cells = split(rows[i], TAB);
      data[rowCount] = cells;
      rowCount++;
    } 
  }

  int getRowCount() {
    return rowCount;
  }
  String getString(int rowIndex, int column) {
    return data[rowIndex][column];
  }
  String getName(int rowIndex) {
    return data[rowIndex][0];
  }

  int getInt(int rowIndex, int column) {
    return parseInt(data[rowIndex][column]);
  }
  float getFloat(int rowIndex, int column) {
    return parseFloat(data[rowIndex][column]);
  }
  float getMin(int column){
    float minVal = MAX_FLOAT;
    for (int row = 0; row < getRowCount(); row++){
      float actVal = getFloat(row,column);
      if (actVal < minVal)  minVal = actVal;
    }
    return minVal;
  }
  float getMax(int column){
    float maxVal = MIN_FLOAT;
    for (int row = 0; row < getRowCount(); row++){
      float actVal = getFloat(row,column);
      if (actVal > maxVal)  maxVal = actVal;
    }
    return maxVal;
  }
  // valeur de difference entre deux colonne de la même ligne
  int getDiff(int row, int column1, int column2){ 
    return  getInt(row,column1)- getInt(row,column2);
  } 

  int diffExtrem(int column1, int column2, boolean high){
    int diff[] = new int[getRowCount()];
    for (int row = 0; row < getRowCount(); row++){
      diff[row] = getInt(row,column1)- getInt(row,column2);
    }
    diff=sort(diff);
    if (high) return diff[getRowCount()-1];
    else return diff[0];
  }
}

