PFont font;
PImage img;
Table region;
// pour simplifier de retrouver les colonnes et ses valeurs associes
final int REG= 0;
final int X=5;
final int Y=6;
final int POP90 = 7;
final int POP99 = 8;
int rowCount;
int diffHigh;
 int diffLow;
 
void setup(){
  font = createFont("ArialMT",12); 
  img = loadImage("france.jpg");
  int w= img.width;
  int h= img.height;
  size(w, h);
  image(img, 0,0);
  smooth();
  noStroke();
  textFont(font,12); 
  region = new Table("regions.tsv");
  rowCount = region.getRowCount();  

// trouve le plus petit / plus grand augmentation  
  diffHigh= region.diffExtrem( POP99, POP90, true);
  diffLow = region.diffExtrem( POP99, POP90, false); 
}

void draw(){ 
  background(img);
    drawDifference();
      //  si la souris est sur une ville, affiche le nom
  for (int row = 0; row< rowCount; row++){
    int x = region.getInt(row, X);
    int y = region.getInt(row, Y);  
    String name = region.getName(row);
    drawName(x, y, name);
  }
}

void drawName(int x, int y, String name){  
  float distance = dist(x, y, mouseX, mouseY);  
  if (distance<10){
    fill(0);
    textAlign(CENTER);
    textSize(12);
    text(name, x, y-8);
  }     
}

// affiche le changement de population en couleur et taille
void drawDifference(){    
    for (int row = 0; row< rowCount; row++){   
   int augm = region.getDiff (row,POP99, POP90);
   float taille = map( augm, diffLow, diffHigh, 5, 40); 
   // si l'augmentation est positif, interpole une couleur relatif entre gris et verte
    if (augm>0){
      float percent = norm(augm, 0, diffHigh);
      color vert = lerpColor(#B4B4B4, #00FF00, percent);
      fill(vert);
    }
       // si l'augmentation est negatif, interpole une couleur relatif entre gris et rouge
    else{
      float percent1 = norm(augm, 0,diffLow);
       //float percent1 = norm(abs(augm), 0, abs(diffLow));
      color rouge = lerpColor(#B4B4B4, #FF0000, percent1);
      fill(rouge);
    }
    int x = region.getInt(row, X);
    int y = region.getInt(row, Y);  
    ellipse(x,y, taille,taille);   
  } 
}

void draw1990(){
  float maxHabit = region.getMax(POP90);
  float minHabit = region.getMin(POP90);
    for (int row = 0; row< rowCount; row++){
    int x = region.getInt(row, X);
    int y = region.getInt(row, Y);  
    float taille = map( region.getFloat(row,POP90),minHabit, maxHabit, 5, 40); 
    noStroke();
    fill(70);
      ellipse(x,y, taille,taille);  
}
}
void draw1999(){
  float maxHabit = region.getMax(POP99);
  float minHabit = region.getMin(POP99);
    for (int row = 0; row< rowCount; row++){
    int x = region.getInt(row, X);
    int y = region.getInt(row, Y);  
    float taille = map( region.getFloat(row,POP99),minHabit, maxHabit, 5, 40); 
     noStroke();
    fill(110);
      ellipse(x,y, taille,taille);  
}
}




